package state51::Job::ChartReports;
use Moose;
use MooseX::Storage;
use MooseX::Types::Moose qw/ Str Int Bool /;
with Storage (format => "JSON");
extends 'state51::Job';

sub exchange_name { 'chartreports' }

has 'start_date' => (
    is            => 'rw',
    isa           => Str,
    documentation => "Date we are reporting for, in the form YYYY-MM-DD or 'today' or 'yesterday'",
    default       => sub {
        return 'today';
    }
);

has 'deliver' => (
    is            => 'rw',
    isa           => Bool,
    documentation => "Should we attempt delivery via ftp? Default is true.",
    default       => sub {
        return 1;
    }
);


sub run {
    my ($self) = @_;
    state51::Script::GenerateChartReports->new(
        deliver => $self->deliver,
        start_date => $self->start_date
    )->run();
}

__PACKAGE__->meta->make_immutable;
1;