package state51::Job::CheckMailout;
use state51::Moose;
use MooseX::Storage;
with Storage (format => "JSON");

use state51::Job::SendMailout;
use MooseX::Types::Moose qw/ Int /;
use state51::Logger;

sub exchange_name { 'mailout_check' }
sub suppress_console_display { 1 }

extends 'state51::Job';

has id => (
    isa => Int,
    is => 'ro',
    required => 1,
);

method run() {
    state51::Logger->new->message(level => 'info', message => [
        state51::Job::SendMailout->new(id => $self->id)
    ]);
}

method lockname() { "mailout_check".$self->id }

with qw/
    
    state51::Mixin::Loggable
    state51::Mixin::LockedJob
/;

__PACKAGE__->meta->make_immutable;
1;

