package state51::Job::FixBrokenFile::Action::File::MashFilesize;
use state51::Moose;
use MooseX::Types::Moose qw/ Int /;

extends qw/ state51::Job::FixBrokenFile::Action::File /;

sub is_terminal { 0; }
has filesize => (
    isa => Int,
    is => 'ro',
    required => 1,
);

sub full_message {
    my ($self) = @_;
    return $self->message."\n\nAction taken: filesize crc32 on ".$self->file->id." and restting dependent transforms\n";
}

sub action {
    my ($self) = @_;
    $self->file->filesize($self->filesize);
    $self->file->update();
    foreach my $x ($self->file->master_of->flatten) {
        $x->reset if $x->is_resettable;
    }
}

__PACKAGE__->meta->make_immutable;
1;

