package state51::Job::FixBrokenFile::Action::File::ReUpload;
use state51::Moose;
use state51::MogileFS;
use MooseX::Types::Moose qw/ Str /;
extends qw/ state51::Job::FixBrokenFile::Action::File /;

sub is_terminal { 0; }
has path => (
    isa => Str,
    is => 'ro',
    required => 1,
);

sub full_message {
    my ($self) = @_;
    return $self->message."\n\nAction taken: reuploading ".$self->file->id." and restting dependent transforms\n";
}

sub action {
    my ($self) = @_;

    # We only upload, we don't touch the metadata as in theory that should be okay.

    my $file = $self->file;
    my $ret = state51::MogileFS::mogfs->store_file(
        $file->_mogile->mogid($file),
        $file->mogile_class,
        $self->path,
    );

    unless ($ret == -s $self->path) {
        die "upload failed: $ret";
    }

    foreach my $x ($self->file->master_of->flatten) {
        $x->reset if $x->is_resettable;
    }
    return;
}

sub DEMOLISH {
    my ($self) = @_;
    unlink $self->path() || warn $!;
    return;
}

__PACKAGE__->meta->make_immutable;
1;

