package state51::Job::FixBrokenFile::Action::FileTransform::Junk;
use Moose;
extends qw/ state51::Job::FixBrokenFile::Action::FileTransform /;

sub is_terminal { 1; }

sub full_message {
    my ($self) = @_;
    return $self->message."\n\nNo action has been taken on ".$self->filetransform->id."\n";
}

sub action {
    my ($self) = @_;

    $self->filetransform->status('unfixable');
    $self->filetransform->update();

    # We should mention the problem in the deliver desires, but as we only junk
    # because of the transform when we have no target track, this is probably
    # rather pointless.

    return;
}

__PACKAGE__->meta->make_immutable;
1;

