package state51::Job::IndexObject;
use state51::Moose;
use MooseX::Storage;
with Storage (format => "JSON");

use MooseX::Types::Moose qw/ Int /;
use MooseX::Types::LoadableClass qw/ LoadableClass /;

extends 'state51::Job';

sub exchange_name { 'searchidx' }

sub suppress_console_display { 1 }

has class => (
    isa => LoadableClass,
    is => 'ro',
    required => 1,
    coerce => 1,
);

has id => (
    isa => Int,
    is => 'ro',
    required => 1,
);

method run() {
    state51::Base->connect;
    my $ob = $self->class->load($self->id);
    $self->cache_delete($ob->cache_flag_key);
    $ob->_index_self;
}

with qw/
    state51::Mixin::Loggable
    state51::Mixin::UnloadAfterJob
/;

__PACKAGE__->meta->make_immutable;
1;

