package state51::Job::SendMailout;
use state51::Moose;
use MooseX::Storage;
with Storage (format => "JSON");

use MooseX::Types::Moose qw/ Int /;

extends 'state51::Job';

sub exchange_name { 'mailout_send' }

has id => (
    isa => Int,
    is => 'ro',
    required => 1,
);

method run() {
    local $ENV{USE_PLATFORM_LDAP} = 0;
    state51::Base->connect;
    my $m = state51::Mailout->load($self->id);
    $m->status("pending") if $m->status eq "running"; # We have the lock - safe to reset!
    $m->run_mail;
}

method lockname() { "mailout_send".$self->id }

with qw/
    state51::Mixin::Loggable
    state51::Mixin::LockedJob
    state51::Mixin::UnloadAfterJob
    state51::Mixin::JobLogger
/;

__PACKAGE__->meta->make_immutable;
1;

