package state51::Mixin::HasLogger;
use Moose::Role;
use Moose::Util::TypeConstraints qw/duck_type/;
use MooseX::Types::Moose qw/Bool/;
use state51::Logger;
use MooseX::Storage ();
use MooseX::Getopt ();
use namespace::autoclean;

has trace => (
    isa => Bool, is => 'rw',
    default => 0,
    traits => [qw/ NoGetopt DoNotSerialize /],
);

has logger => (
    isa => duck_type(['message']), is => 'ro',
    lazy => 1,
    default => sub {
        state51::Logger->new(trace => shift->trace)
    },
    traits => [qw/ NoGetopt DoNotSerialize /],
);

sub log_message {
    my $self = shift;
    # we can't rely on this to not crap out with a non-useful error message on Xenial
    # because state51-logger is a garbage fire, so wrap it in eval
    eval {
        $self->logger->message(@_);
    }
}

1;

