package state51::Mixin::JobSignature;
use Moose::Role;
use Function::Parameters;
use namespace::autoclean;

# XXX WTF $job_name is unused!
method job_signature($job_name='') {
    my $by = getlogin() || getpwuid($<);
    my $my_hostname = (split('\.',Sys::Hostname::hostname()))[0];
    my $mode = '';
    if ($self->can('interactive')) {
      $mode = 'in interactive mode' if $self->interactive;
    }
    return sprintf("\n\n-- \n Job: %s (platform: %s) ran at %s in worker PID %s on %s by %s %s\n",
        ref($self), $state51::Base::VERSION, state51::Base->dbnow, $$, $my_hostname, $by||'RabbitMQ', $mode
    );
}
1;

